/*******************************************************************************
 * Copyright (c) 2010 by Thomas Jahn
 * Questions or license requests? Mail me at lithander@gmx.de!
 ******************************************************************************/
package net.pixelpracht.tmx 
{
	public class TmxObject
	{
		public var group:TmxObjectGroup;
		public var name:String;
		public var type:String;
		public var x:int;
		public var y:int;
		public var width:int;
		public var height:int;
		public var gid:int;
		public var custom:TmxPropertySet;
		public var shared:TmxPropertySet;
		
		public function TmxObject(source:XML, parent:TmxObjectGroup)
		{
			group = parent;
			name = source.@name;
			type = source.@type;
			x = source.@x; 
			y = source.@y; 
			width = source.@width; 
			height = source.@height;
			//resolve inheritence
			shared = null;
			gid = -1;
			if(source.@gid.length != 0) //object with tile association?
			{
				gid = source.@gid;
				for each(var tileSet:TmxTileSet in group.map.tileSets)
				{
					shared = tileSet.getPropertiesByGid(gid);
					if(shared)
						break;
				}
			}
			
			//load properties
			var node:XML;
			for each(node in source.properties)
				custom = custom ? custom.extend(node) : new TmxPropertySet(node);
		}
	}
}