package render3d.interfaces 
{
	import flash.display.BitmapData;
	import flash.geom.ColorTransform;
	import flash.geom.Matrix3D;
	import flash.geom.Vector3D;
	import render3d.interfaces.abstract.IRender3DAbstract;
	
	/**
	 * Narrow interface of Render3D for CrossEngineObject3D
	 * @author Exey Panteleev
	 */
	public interface IRender3DForObject3D extends IRender3DAbstract
	{
		function get FORWARD():Vector3D;
		function get BACKWARD():Vector3D;		
		
		function copyTransformation( sourceMatrix3D:Matrix3D, targetObject3D:* ):void;
		function copyPosition( sourceMatrix3D:Matrix3D, targetObject3D:* ):void;
		function rotateAxis( matrix3D:Matrix3D, vector3D:Vector3D ):void;
		function changeTexture( bitmapData:BitmapData, targetObject3D:* ):void;
	}
}